diff --git a/libkmod/libkmod-builtin.c b/libkmod/libkmod-builtin.c
index 66f9469..fd0f549 100644
--- a/libkmod/libkmod-builtin.c
+++ b/libkmod/libkmod-builtin.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel built-in modules
- *
  * Copyright (C) 2019  Alexey Gladkov <gladkov.alexey@gmail.com>
  */
 
diff --git a/libkmod/libkmod-config.c b/libkmod/libkmod-config.c
index af9b93e..919f4ed 100644
--- a/libkmod/libkmod-config.c
+++ b/libkmod/libkmod-config.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  * Copyright (C) 2013  Intel Corporation. All rights reserved.
  */
diff --git a/libkmod/libkmod-elf.c b/libkmod/libkmod-elf.c
index 93bf66c..06a9876 100644
--- a/libkmod/libkmod-elf.c
+++ b/libkmod/libkmod-elf.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-file.c b/libkmod/libkmod-file.c
index b39c32d..c6c1e22 100644
--- a/libkmod/libkmod-file.c
+++ b/libkmod/libkmod-file.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-index.c b/libkmod/libkmod-index.c
index b6245f2..b7f8bd3 100644
--- a/libkmod/libkmod-index.c
+++ b/libkmod/libkmod-index.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-index.h b/libkmod/libkmod-index.h
index 850b506..5f0657e 100644
--- a/libkmod/libkmod-index.h
+++ b/libkmod/libkmod-index.h
@@ -1,7 +1,5 @@
 /* SPDX-License-Identifier: LGPL-2.1-or-later */
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-list.c b/libkmod/libkmod-list.c
index ad07587..38a3c27 100644
--- a/libkmod/libkmod-list.c
+++ b/libkmod/libkmod-list.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-module.c b/libkmod/libkmod-module.c
index b08393f..c095e63 100644
--- a/libkmod/libkmod-module.c
+++ b/libkmod/libkmod-module.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod-signature.c b/libkmod/libkmod-signature.c
index 7e3b973..48caf74 100644
--- a/libkmod/libkmod-signature.c
+++ b/libkmod/libkmod-signature.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - module signature display
- *
  * Copyright (C) 2013 Michal Marek, SUSE
  */
 
diff --git a/libkmod/libkmod.c b/libkmod/libkmod.c
index 7704cac..7953716 100644
--- a/libkmod/libkmod.c
+++ b/libkmod/libkmod.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/libkmod/libkmod.h b/libkmod/libkmod.h
index b6273a0..f3376f5 100644
--- a/libkmod/libkmod.h
+++ b/libkmod/libkmod.h
@@ -1,7 +1,5 @@
 /* SPDX-License-Identifier: LGPL-2.1-or-later */
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/m4/attributes.m4 b/m4/attributes.m4
index 208dfdc..63aca0a 100644
--- a/m4/attributes.m4
+++ b/m4/attributes.m4
@@ -1,6 +1,5 @@
 dnl SPDX-License-Identifier: GPL-2.0-or-later
 dnl
-dnl Macros to check the presence of generic (non-typed) symbols.
 dnl Copyright (c) 2006-2008 Diego Pettenò <flameeyes@gmail.com>
 dnl Copyright (c) 2006-2008 xine project
 dnl Copyright (c) 2012 Lucas De Marchi <lucas.de.marchi@gmail.com>
diff --git a/shared/array.c b/shared/array.c
index 128c9fc..f63ca50 100644
--- a/shared/array.c
+++ b/shared/array.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/shared/hash.c b/shared/hash.c
index 9eb87d8..37a8396 100644
--- a/shared/hash.c
+++ b/shared/hash.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/shared/macro.h b/shared/macro.h
index e8a890a..d70c0b7 100644
--- a/shared/macro.h
+++ b/shared/macro.h
@@ -1,7 +1,5 @@
 /* SPDX-License-Identifier: LGPL-2.1-or-later */
 /*
- * kmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 #pragma once
diff --git a/shared/scratchbuf.c b/shared/scratchbuf.c
index e995755..5c51e4b 100644
--- a/shared/scratchbuf.c
+++ b/shared/scratchbuf.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * kmod - interface to kernel module operations
- *
  * Copyright (C) 2016  Intel Corporation. All rights reserved.
  */
 #include "scratchbuf.h"
diff --git a/shared/strbuf.c b/shared/strbuf.c
index 9a8ebea..0b63166 100644
--- a/shared/strbuf.c
+++ b/shared/strbuf.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * libkmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  * Copyright (C) 2014  Intel Corporation. All rights reserved.
  */
diff --git a/shared/util.c b/shared/util.c
index 5c1afb9..66a7622 100644
--- a/shared/util.c
+++ b/shared/util.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: LGPL-2.1-or-later
 /*
- * kmod - interface to kernel module operations
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  * Copyright (C) 2012  Lucas De Marchi <lucas.de.marchi@gmail.com>
  * Copyright (C) 2013-2014  Intel Corporation. All rights reserved.
diff --git a/shell-completion/bash/kmod b/shell-completion/bash/kmod
index 6c66dc3..7dd3d33 100644
--- a/shell-completion/bash/kmod
+++ b/shell-completion/bash/kmod
@@ -1,8 +1,6 @@
 # kmod completion                                          -*- shell-script -*-
 # SPDX-License-Identifier: LGPL-2.1-or-later
 #
-# This file is part of kmod.
-#
 # Copyright 2010 Ran Benita
 # Copyright (C) 2013  Intel Corporation. All rights reserved.
 
diff --git a/tools/depmod.c b/tools/depmod.c
index 8113721..661cfc4 100644
--- a/tools/depmod.c
+++ b/tools/depmod.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod-depmod - calculate modules.dep  using libkmod.
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/insmod.c b/tools/insmod.c
index 7c3ed04..4a1d11d 100644
--- a/tools/insmod.c
+++ b/tools/insmod.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod-insmod - insert modules into linux kernel using libkmod.
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/kmod.c b/tools/kmod.c
index 989d343..d28ec7b 100644
--- a/tools/kmod.c
+++ b/tools/kmod.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod - one tool to rule them all
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/kmod.h b/tools/kmod.h
index f4d5e13..c3c8683 100644
--- a/tools/kmod.h
+++ b/tools/kmod.h
@@ -1,7 +1,5 @@
 /* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
- * kmod - one tool to rule them all
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/log.c b/tools/log.c
index 050ecb2..e2fe9a7 100644
--- a/tools/log.c
+++ b/tools/log.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod - log infrastructure
- *
  * Copyright (C) 2012-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/log.h b/tools/log.h
index 20d39a1..72836be 100644
--- a/tools/log.h
+++ b/tools/log.h
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod - log infrastructure
- *
  * Copyright (C) 2012-2013  ProFUSION embedded systems
  */
 
diff --git a/tools/lsmod.c b/tools/lsmod.c
index 2c2e62a..323aad6 100644
--- a/tools/lsmod.c
+++ b/tools/lsmod.c
@@ -1,7 +1,5 @@
 // SPDX-License-Identifier: GPL-2.0-or-later
 /*
- * kmod-lsmod - list modules from linux kernel using libkmod.
- *
  * Copyright (C) 2011-2013  ProFUSION embedded systems
  */
 